{
  (> TAccess97Password <)

  Utility:
  - Revelate Microsoft Database Files (.MDB) Protection Password

  Versions:
  - It could recover Access 95/97 MDB Passwords

  Access decryption engine developed by Rodrigo Hjort, from Brasil!
  - E-mail: rodrigo_hjort@yahoo.com
  - Home Page: http://www.geocities.com/SiliconValley/Peaks/4093
               http://www.pyrosoft.8m.com

  Component development by Mike Shkolnik
  - E-mail: mshkolnik@scalabium.com
  - Home Page: http://www.scalabium.com
}

unit Acc97Pwd;

interface

uses
  Windows, Classes, Forms, SysUtils, Dialogs, 
//  Messages, Graphics, Controls, {units not used in the application}
  DsgnIntf;

{comment a next line for complete version. Else - demo version}
//{$DEFINE Acc97PW_DEMO}

type
  TAccessAboutProperty = class(TPropertyEditor)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;
  TAccessFileNameProperty = class(TStringProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;
  TAccess97Password = class(TComponent)
  private
    { Private declarations }
    FAbout: TAccessAboutProperty;
    {file name for Access'97 Database}
    FFileName: string;
    FFileSize: longint;
    {properties for decrypted&encrypted password
    PS: FPasswordEncrypted declaration can move in SetFileName procedure if you not use it as visible}
    FPassword: string;
    FPasswordEncrypted: string;
    FLinha: string;
    {user notify event: after filename changing for password update}
    FPasswordChange: TNotifyEvent;
    function ProcurarCod(iCol: Short; cCar: Char): Char;
    procedure SetFileName(Value: string);
    procedure SetNothingBoolean(Value: Boolean);
    procedure SetNothingInteger(Value: Longint);
    procedure SetNothingString(Value: String);
  protected
    { Protected declarations }
  public
    { Public declarations }
    {declare a Passwords properties as public but readonly}
    sSenhaC: array[1..13] of Char;
    function IsDemo: Boolean;
    property Linha: string read FLinha;
    property PasswordEncrypted: string read FPasswordEncrypted;
  published
    { Published declarations }
    property About: TAccessAboutProperty read FAbout write FAbout;
    property DemoVersion: Boolean read IsDemo write SetNothingBoolean;
    property FileName: string read FFileName write SetFileName;
    property SizeOfFile: longint read FFileSize write SetNothingInteger;
    property Password: string read FPassword write SetNothingString;
    property PasswordChange: TNotifyEvent read FPasswordChange write FPasswordChange;
  end;

procedure Register;
procedure ShowAbout;

implementation

procedure Register;
begin
  RegisterComponents('Samples', [TAccess97Password]);
  RegisterPropertyEditor(TypeInfo(TAccessAboutProperty), TAccess97Password, 'ABOUT', TAccessAboutProperty);
  RegisterPropertyEditor(TypeInfo(string), TAccess97Password, 'FileName', TAccessFileNameProperty);
end;

const
  _COL  = 14;
  _LIN1 = 33;
  _LIN2 = 32;
  _LIN3 = 30;
  _LIN4 = 01;
  _LIN5 = 26;

  {These were divided into 5 arrays, cuz there was a bug
   If someone could make it into one, send me please.}

  {These ASCII Tables I got from Access itself, after spending hours in front of
   the computer! Can someone find out this encryption that with only one function
   the decodified char is returned? If so, e-mail me.}

  iCodASCII1  : Array[1..(_COL * _LIN1)] of Byte =
{ 1    2    3    4    5    6    7    8    9   10   11   12   13   14 }
(
   0, 134, 251, 236,  55,  93,  68, 156, 250, 198,  94,  40, 230,  19, //nulo
  32, 166, 219, 204,  23, 125, 100, 188, 218, 230, 126,   8, 198,  51, //espao
  33, 167, 218, 205,  22, 124, 101, 189, 219, 231, 127,   9, 199,  50, //!
  34, 164, 217, 206,  21, 127, 102, 190, 216, 228, 124,  10, 196,  49, //"
  35, 165, 216, 207,  20, 126, 103, 191, 217, 229, 125,  11, 197,  48, //#
  36, 162, 223, 200,  19, 121,  96, 184, 222, 226, 122,  12, 194,  55, //$
  37, 163, 222, 201,  18, 120,  97, 185, 223, 227, 123,  13, 195,  54, //%
  38, 160, 221, 202,  17, 123,  98, 186, 220, 224, 120,  14, 192,  53, //&
  39, 161, 220, 203,  16, 122,  99, 187, 221, 225, 121,  15, 193,  52, //'
  40, 174, 211, 196,  31, 117, 108, 180, 210, 238, 118,   0, 206,  59, //(
  41, 175, 210, 197,  30, 116, 109, 181, 211, 239, 119,   1, 207,  58, //)
  42, 172, 209, 198,  29, 119, 110, 182, 208, 236, 116,   2, 204,  57, //*
  43, 173, 208, 199,  28, 118, 111, 183, 209, 237, 117,   3, 205,  56, //+
  44, 170, 215, 192,  27, 113, 104, 176, 214, 234, 114,   4, 202,  63, //,
  45, 171, 214, 193,  26, 112, 105, 177, 215, 235, 115,   5, 203,  62, //-
  46, 168, 213, 194,  25, 115, 106, 178, 212, 232, 112,   6, 200,  61, //.
  47, 169, 212, 195,  24, 114, 107, 179, 213, 233, 113,   7, 201,  60, ///
  48, 182, 203, 220,   7, 109, 116, 172, 202, 246, 110,  24, 214,  35, //0
  49, 183, 202, 221,   6, 108, 117, 173, 203, 247, 111,  25, 215,  34, //1
  50, 180, 201, 222,   5, 111, 118, 174, 200, 244, 108,  26, 212,  33, //2
  51, 181, 200, 223,   4, 110, 119, 175, 201, 245, 109,  27, 213,  32, //3
  52, 178, 207, 216,   3, 105, 112, 168, 206, 242, 106,  28, 210,  39, //4
  53, 179, 206, 217,   2, 104, 113, 169, 207, 243, 107,  29, 211,  38, //5
  54, 176, 205, 218,   1, 107, 114, 170, 204, 240, 104,  30, 208,  37, //6
  55, 177, 204, 219,   0, 106, 115, 171, 205, 241, 105,  31, 209,  36, //7
  56, 190, 195, 212,  15, 101, 124, 164, 194, 254, 102,  16, 222,  43, //8
  57, 191, 194, 213,  14, 100, 125, 165, 195, 255, 103,  17, 223,  42, //9
  58, 188, 193, 214,  13, 103, 126, 166, 192, 252, 100,  18, 220,  41, //: (; invlido)
  60, 186, 199, 208,  11,  97, 120, 160, 198, 250,  98,  20, 218,  47, //<
  61, 187, 198, 209,  10,  96, 121, 161, 199, 251,  99,  21, 219,  46, //=
  62, 184, 197, 210,   9,  99, 122, 162, 196, 248,  96,  22, 216,  45, //>
  63, 185, 196, 211,   8,  98, 123, 163, 197, 249,  97,  23, 217,  44, //?
  64, 198, 187, 172, 119,  29,   4, 220, 186, 134,  30, 104, 166,  83  //@
);

  iCodASCII2  : Array[1..(_COL * _LIN2)] of Byte =
{ 1    2    3    4    5    6    7    8    9   10   11   12   13   14 }
(
  65, 199, 186, 173, 118,  28,   5, 221, 187, 135,  31, 105, 167,  82, //A
  66, 196, 185, 174, 117,  31,   6, 222, 184, 132,  28, 106, 164,  81, //B
  67, 197, 184, 175, 116,  30,   7, 223, 185, 133,  29, 107, 165,  80, //C
  68, 194, 191, 168, 115,  25,   0, 216, 190, 130,  26, 108, 162,  87, //D
  69, 195, 190, 169, 114,  24,   1, 217, 191, 131,  27, 109, 163,  86, //E
  70, 192, 189, 170, 113,  27,   2, 218, 188, 128,  24, 110, 160,  85, //F
  71, 193, 188, 171, 112,  26,   3, 219, 189, 129,  25, 111, 161,  84, //G
  72, 206, 179, 164, 127,  21,  12, 212, 178, 142,  22,  96, 174,  91, //H
  73, 207, 178, 165, 126,  20,  13, 213, 179, 143,  23,  97, 175,  90, //I
  74, 204, 177, 166, 125,  23,  14, 214, 176, 140,  20,  98, 172,  89, //J
  75, 205, 176, 167, 124,  22,  15, 215, 177, 141,  21,  99, 173,  88, //K
  76, 202, 183, 160, 123,  17,   8, 208, 182, 138,  18, 100, 170,  95, //L
  77, 203, 182, 161, 122,  16,   9, 209, 183, 139,  19, 101, 171,  94, //M
  78, 200, 181, 162, 121,  19,  10, 210, 180, 136,  16, 102, 168,  93, //N
  79, 201, 180, 163, 120,  18,  11, 211, 181, 137,  17, 103, 169,  92, //O
  80, 214, 171, 188, 103,  13,  20, 204, 170, 150,  14, 120, 182,  67, //P
  81, 215, 170, 189, 102,  12,  21, 205, 171, 151,  15, 121, 183,  66, //Q
  82, 212, 169, 190, 101,  15,  22, 206, 168, 148,  12, 122, 180,  65, //R
  83, 213, 168, 191, 100,  14,  23, 207, 169, 149,  13, 123, 181,  64, //S
  84, 210, 175, 184,  99,   9,  16, 200, 174, 146,  10, 124, 178,  71, //T
  85, 211, 174, 185,  98,   8,  17, 201, 175, 147,  11, 125, 179,  70, //U
  86, 208, 173, 186,  97,  11,  18, 202, 172, 144,   8, 126, 176,  69, //V
  87, 209, 172, 187,  96,  10,  19, 203, 173, 145,   9, 127, 177,  68, //W
  88, 222, 163, 180, 111,   5,  28, 196, 162, 158,   6, 112, 190,  75, //Y
  89, 223, 162, 181, 110,   4,  29, 197, 163, 159,   7, 113, 191,  74, //X
  90, 220, 161, 182, 109,   7,  30, 198, 160, 156,   4, 114, 188,  73, //Z
  91, 221, 160, 183, 108,   6,  31, 199, 161, 157,   5, 115, 189,  72, //[
  92, 218, 167, 176, 107,   1,  24, 192, 166, 154,   2, 116, 186,  79, //\
  93, 219, 166, 177, 106,   0,  25, 193, 167, 155,   3, 117, 187,  78, //]
  94, 216, 165, 178, 105,   3,  26, 194, 164, 152,   0, 118, 184,  77, //^
  95, 217, 164, 179, 104,   2,  27, 195, 165, 153,   1, 119, 185,  76, //_
  96, 230, 155, 140,  87,  61,  36, 252, 154, 166,  62,  72, 134, 115  //`
);

  iCodASCII3  : Array[1..(_COL * _LIN3)] of Byte =
{ 1    2    3    4    5    6    7    8    9   10   11   12   13   14 }
(
  97, 231, 154, 141,  86,  60,  37, 253, 155, 167,  63,  73, 135, 114, //a
  98, 228, 153, 142,  85,  63,  38, 254, 152, 164,  60,  74, 132, 113, //b
  99, 229, 152, 143,  84,  62,  39, 255, 153, 165,  61,  75, 133, 112, //c
 100, 226, 159, 136,  83,  57,  32, 248, 158, 162,  58,  76, 130, 119, //d
 101, 227, 158, 137,  82,  56,  33, 249, 159, 163,  59,  77, 131, 118, //e
 102, 224, 157, 138,  81,  59,  34, 250, 156, 160,  56,  78, 128, 117, //f
 103, 225, 156, 139,  80,  58,  35, 251, 157, 161,  57,  79, 129, 116, //g
 104, 238, 147, 132,  95,  53,  44, 244, 146, 174,  54,  64, 142, 123, //h
 105, 239, 146, 133,  94,  52,  45, 245, 147, 175,  55,  65, 143, 122, //i
 106, 236, 145, 134,  93,  55,  46, 246, 144, 172,  52,  66, 140, 121, //j
 107, 237, 144, 135,  92,  54,  47, 247, 145, 173,  53,  67, 141, 120, //k
 108, 234, 151, 128,  91,  49,  40, 240, 150, 170,  50,  68, 138, 127, //l
 109, 235, 150, 129,  90,  48,  41, 241, 151, 171,  51,  69, 139, 126, //m
 110, 232, 149, 130,  89,  51,  42, 242, 148, 168,  48,  70, 136, 125, //n
 111, 233, 148, 131,  88,  50,  43, 243, 149, 169,  49,  71, 137, 124, //o
 112, 246, 139, 156,  71,  45,  52, 236, 138, 182,  46,  88, 150,  99, //p
 113, 247, 138, 157,  70,  44,  53, 237, 139, 183,  47,  89, 151,  98, //q
 114, 244, 137, 158,  69,  47,  54, 238, 136, 180,  44,  90, 148,  97, //r
 115, 245, 136, 159,  68,  46,  55, 239, 137, 181,  45,  91, 149,  96, //s
 116, 242, 143, 152,  67,  41,  48, 232, 142, 178,  42,  92, 146, 103, //t
 117, 243, 142, 153,  66,  40,  49, 233, 143, 179,  43,  93, 147, 102, //u
 118, 240, 141, 154,  65,  43,  50, 234, 140, 176,  40,  94, 144, 101, //v
 119, 241, 140, 155,  64,  42,  51, 235, 141, 177,  41,  95, 145, 100, //w
 120, 254, 131, 148,  79,  37,  60, 228, 130, 190,  38,  80, 158, 107, //x
 121, 255, 130, 149,  78,  36,  61, 229, 131, 191,  39,  81, 159, 106, //y
 122, 252, 129, 150,  77,  39,  62, 230, 128, 188,  36,  82, 156, 105, //z
 123, 253, 128, 151,  76,  38,  63, 231, 129, 189,  37,  83, 157, 104, //{
 124, 250, 135, 144,  75,  33,  56, 224, 134, 186,  34,  84, 154, 111, //|
 125, 251, 134, 145,  74,  32,  57, 225, 135, 187,  35,  85, 155, 110, //}
 126, 248, 133, 146,  73,  35,  58, 226, 132, 184,  32,  86, 152, 109  //~
);

  {ASCII Table 4 is not completed yet... there are missing bytes from 209 to 223}
  iCodASCII4  : Array[1..(_COL * _LIN4)] of Byte =
{ 1    2    3    4    5    6    7    8    9   10   11   12   13   14 }
(
 195,  69,  56,  47, 244, 158, 135,  95,  57,   5, 157, 235,  37, 208 //
);

  iCodASCII5  : Array[1..(_COL * _LIN5)] of Byte =
{ 1    2    3    4    5    6    7    8    9   10   11   12   13   14 }
(
 224, 102,  27,  12, 215, 189, 164, 124,  26,  38, 190, 200,   6, 243, //
 225, 103,  26,  13, 214, 188, 165, 125,  27,  39, 191, 201,   7, 242, //
 226, 100,  25,  14, 213, 191, 166, 126,  24,  36, 188, 202,   4, 241, //
 227, 101,  24,  15, 212, 190, 167, 127,  25,  37, 189, 203,   5, 240, //
 228,  98,  31,   8, 211, 185, 160, 120,  30,  34, 186, 204,   2, 247, //
 231,  97,  28,  11, 208, 186, 163, 123,  29,  33, 185, 207,   1, 244, //
 232, 110,  19,   4, 223, 181, 172, 116,  18,  46, 182, 192,  14, 251, //
 233, 111,  18,   5, 222, 180, 173, 117,  19,  47, 183, 193,  15, 250, //
 234, 108,  17,   6, 221, 183, 174, 118,  16,  44, 180, 194,  12, 249, //
 235, 109,  16,   7, 220, 182, 175, 119,  17,  45, 181, 195,  13, 248, //
 236, 106,  23,   0, 219, 177, 168, 112,  22,  42, 178, 196,  10, 255, //
 237, 107,  22,   1, 218, 176, 169, 113,  23,  43, 179, 197,  11, 254, //
 238, 104,  21,   2, 217, 179, 170, 114,  20,  40, 176, 198,   8, 253, //
 239, 105,  20,   3, 216, 178, 171, 115,  21,  41, 177, 199,   9, 252, //
 241, 119,  10,  29, 198, 172, 181, 109,  11,  55, 175, 217,  23, 226, //
 242, 116,   9,  30, 197, 175, 182, 110,   8,  52, 172, 218,  20, 225, //
 243, 117,   8,  31, 196, 174, 183, 111,   9,  53, 173, 219,  21, 224, //
 244, 114,  15,  24, 195, 169, 176, 104,  14,  50, 170, 220,  18, 231, //
 245, 115,  14,  25, 194, 168, 177, 105,  15,  51, 171, 221,  19, 230, //
 246, 112,  13,  26, 193, 171, 178, 106,  12,  48, 168, 222,  16, 229, //
 249, 127,   2,  21, 206, 164, 189, 101,   3,  63, 167, 209,  31, 234, //
 250, 124,   1,  22, 205, 167, 190, 102,   0,  60, 164, 210,  28, 233, //
 251, 125,   0,  23, 204, 166, 191, 103,   1,  61, 165, 211,  29, 232, //
 252, 122,   7,  16, 203, 161, 184,  96,   6,  58, 162, 212,  26, 239, //
 253, 123,   6,  17, 202, 160, 185,  97,   7,  59, 163, 213,  27, 238, //
 255, 121,   4,  19, 200, 162, 187,  99,   5,  57, 161, 215,  25, 236  //
);

function TAccess97Password.ProcurarCod(iCol: Short; cCar: Char): Char;
var
  iCont: Short;
begin
  Result := '';
  for iCont := 0 to _LIN1 - 1 do
    if (iCodASCII1[(iCont * _COL) + iCol + 1] = Ord(cCar)) then begin
      Result := Char(iCodASCII1[(iCont * _COL) + 1]);
      exit;
    end;
  if IsDemo then exit;
  for iCont := 0 to _LIN2 - 1 do
    if (iCodASCII2[(iCont * _COL) + iCol + 1] = Ord(cCar)) then begin
      Result := Char(iCodASCII2[(iCont * _COL) + 1]);
      exit;
    end;
  for iCont := 0 to _LIN3 - 1 do
    if (iCodASCII3[(iCont * _COL) + iCol + 1] = Ord(cCar)) then begin
      Result := Char(iCodASCII3[(iCont * _COL) + 1]);
      exit;
    end;
  for iCont := 0 to _LIN4 - 1 do
    if (iCodASCII4[(iCont * _COL) + iCol + 1] = Ord(cCar)) then begin
      Result := Char(iCodASCII4[(iCont * _COL) + 1]);
      exit;
    end;
  for iCont := 0 to _LIN5 - 1 do
    if (iCodASCII5[(iCont * _COL) + iCol + 1] = Ord(cCar)) then begin
      Result := Char(iCodASCII5[(iCont * _COL) + 1]);
      exit;
    end;
end;

procedure TAccess97Password.SetFileName(Value: String);
var
  iCont, iNum: Integer;
  fArquivo   : File;
  sBuffer    : array[1..80] of Char;
begin
  iNum := 0;
  if ((FFileName <> Value) and (FileExists(Value))) then begin
    FPassword := '';
    FPasswordEncrypted := '';
    FFileName := Value;
    AssignFile(fArquivo, FFileName);
    Reset(fArquivo, 1);
    FFileSize := FileSize(fArquivo);
    repeat
      BlockRead(fArquivo, sBuffer, SizeOf(sBuffer), iCont);
    until (iCont = 0) or (iCont <> iNum);
    CloseFile(fArquivo);
    FLinha := '';
    for iCont := 1 to 80 do
      FLinha := FLinha + sBuffer[iCont];
    for iCont := 1 to 13 do begin
      sSenhaC[iCont] := sBuffer[iCont + 66];
      FPasswordEncrypted := FPasswordEncrypted + sSenhaC[iCont];
      FPassword := FPassword + ProcurarCod(iCont, sSenhaC[iCont]);
    end;
    if Assigned(FPasswordChange) then FPasswordChange(Self);
    ShowAbout;
  end;
end;

procedure TAccess97Password.SetNothingBoolean(Value: Boolean); begin {} end;

procedure TAccess97Password.SetNothingString(Value: String); begin {} end;

procedure TAccess97Password.SetNothingInteger(Value: Longint); begin {} end;

function TAccess97Password.IsDemo: Boolean;
begin
  {$IFDEF Acc97PW_DEMO}
  Result := True;
  {$ELSE}
  Result := False;
  {$ENDIF Acc97PW_DEMO}
end;

procedure ShowAbout;
begin
  Application.MessageBox
    ('Microsoft Access''97 Database Password Revelation' + #13 + #10 + #13 + #10 +
     '- Rodrigo Hjort (rodrigo_hjort@yahoo.com)' + #13 + #10 +
     '  http://www.geocities.com/SiliconValley/Peaks/4093' + #10 + #10 +
     '- Mike Shkolnik (MShkolnik@rs-ukraine.kiev.ua)' + #13 + #10 +
     '  http://www.geocities.com/SiliconValley/Grid/3989',
     'About TAccess97Password', MB_OK or MB_ICONINFORMATION);
end;

{ TAccessFileNameProperty }
{ For FileName selection in TAccess97Password component (select a Access database file) }

procedure TAccessFileNameProperty.Edit;
var
  Comp: TAccess97Password;
begin
  with TOpenDialog.Create(nil) do
    try
      Comp := (GetComponent(0) as TAccess97Password);
      FileName := Comp.FileName;
      Filter := 'Access Database (*.mdb)|*.mdb|All files (*.*)|*.*';
      DefaultExt := 'mdb';
      if Execute then Comp.FileName := FileName;
    finally
      free
    end;
end;

function TAccessFileNameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paMultiSelect, paDialog];
end;

procedure TAccessAboutProperty.Edit;
begin
  ShowAbout;
end;

function TAccessAboutProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paMultiSelect, paDialog, paReadOnly];
end;

function TAccessAboutProperty.GetValue: String;
begin
  Result := '(About...)';
end;

end.
